package com.kasetoatz.boatjump.mixin;

import com.kasetoatz.boatjump.BoatJump;
import net.minecraft.entity.Entity;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.vehicle.BoatEntity;
import org.jetbrains.annotations.Nullable;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(Entity.class)
public abstract class EntityMixin {
    @Shadow @Nullable public abstract LivingEntity getControllingPassenger();

    @Inject(method="getStepHeight", at = @At("HEAD"), cancellable = true)
    public void getStepHeight(CallbackInfoReturnable<Float> cir) {
        if ((Entity)(Object)this instanceof BoatEntity && this.getControllingPassenger() == BoatJump.client.player) {
            cir.setReturnValue(1.f);
        }
    }
}
